Attribute VB_Name = "modActivateOtherInstance"
Option Explicit

Private Declare Function EnumWindows Lib "user32" ( _
    ByVal lpEnumFunc As Long, _
    ByVal LParam As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" ( _
    ByVal hwnd As Long, _
    ByVal lpClassName As String, _
    ByVal nMaxCount As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32" ( _
    ByVal hwnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" ( _
    ByVal hwnd As Long, _
    ByVal lpString As String, _
    ByVal cch As Long) As Long
Private Ndx As Long
Private XLHWnd(0 To 9) As Long

Sub ActivateOtherInstance()
    Dim MyHWnd As Long
    Dim R As Long
    Dim N As Long
    
    Ndx = 0
    Erase XLHWnd
    MyHWnd = Application.hwnd
    XLHWnd(0) = MyHWnd
    Ndx = 1
    R = EnumWindows(AddressOf EnumWND, 0)
    For N = LBound(XLHWnd) To UBound(XLHWnd)
        If XLHWnd(N) <> 0 Then
            If XLHWnd(N) <> MyHWnd Then
                'Debug.Print "OTHER: " & CStr(XLHWnd(N))
                R = SetForegroundWindow(XLHWnd(N))
                Exit Sub
            End If
        End If
    Next N
End Sub

Public Function EnumWND(ByVal hwnd As Long, ByVal LParam As Long) As Long
    Dim ClassName As String
    Dim R As Long
    Dim N As Long
    Dim S As String
    Dim WindowText As String
    
    ClassName = String(255, vbNullChar)
    R = GetClassName(hwnd, ClassName, 255)
    N = InStr(ClassName, vbNullChar)
    ClassName = Left(ClassName, N - 1)
    
    WindowText = String(255, vbNullChar)
    R = GetWindowText(hwnd, WindowText, 255)
    N = InStr(WindowText, vbNullChar)
    WindowText = Left(WindowText, N - 1)
    
    If StrComp(ClassName, "XLMAIN", vbTextCompare) = 0 Then
        If WindowText <> vbNullString Then
            If StrComp(WindowText, "Excel", vbTextCompare) <> 0 Then
                'Debug.Print CStr(hwnd), ClassName, WindowText
                XLHWnd(Ndx) = hwnd
                Ndx = Ndx + 1
            End If
        End If
    End If
    EnumWND = 1
End Function
